//////////////////////////////////////////////////////////////////////////////////
// EEE4084F Digital Systems Verilog Prac
//////////////////////////////////////////////////////////////////////////////////

// Simulation sessing
`timescale 1ns / 1ps

//////////////////////////////////////////////////////////////////////////////////
module func2(
    input clk,
    input ce,
    input rst,
    output [7:0] q
    );

	// This is used so that our program runs in Human Speed. 
	// We will alter this Delay throughout the Prac, so be sure to leave 
	// this line as is, until otherwise specified.
	parameter DELAY = 24'h000004;
	
	// tmp is the register that we will be shifting
	reg [23:0] tmp = 24'h0000FF;
	// pre_count is used to for generating the delay. Initial value is HEX "00...00" 
	reg [23:0] pre_count = 24'h000000;
	// shift_count is used to keep track of where we are in the shift operation
	reg [4:0] shift_count = 5'h00;
	
	always @(posedge clk) begin

		// TODO: This is where your shifter goes.
		
		// This code can be used to perform your shift
		/*if(shift_count > 5'h0F) begin 
			tmp <= tmp >> 1'h1;
			shift_count <= shift_count + 1'h1;
		end	else begin
			tmp <= tmp << 1'h1;
			shift_count <= shift_count + 1'h1;
		end*/
	end
	
	//Output the register value to the port
	assign q = tmp[15:8];

endmodule
