//////////////////////////////////////////////////////////////////////////////////
// EEE4084F Digital Systems Verilog Prac
//////////////////////////////////////////////////////////////////////////////////

// Simulation sessing
`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////

module func2_tb;

	// Inputs
	reg clk;
	reg ce;
	reg rst;

	// Outputs
	wire [7:0] q;

	// Instantiate the Unit Under Test (UUT)
	func2 uut (
		.clk(clk), 
		.ce(ce), 
		.rst(rst), 
		.q(q)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		ce = 0;
		rst = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
		// Add stimulus here
		ce = 1;
		
		// Wait 100 ns for global reset to finish
		#800;
		
		rst = 1;
		
		// Wait 100 ns for global reset to finish
		#100;

	end
	
	// oscillate clock every 10 simulation units
	always #20 clk <= ~clk;
      
endmodule
