----------------------------------------------------------------------------------
-- EEE4084F Prac : VHDL to Verilog experimentation
-- First implement the counter in VHDL, see line 43
----------------------------------------------------------------------------------
-- Includes
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity func1 is
	generic (
		--This is used so that our program runs in Human Speed. 
		--We will alter this Delay throughout the Prac, so be sure to leave 
		--this line as is, until otherwise specified.
		DELAY : unsigned (23 downto 0) := x"000004"	
	);
	Port ( 
		clk : in  STD_LOGIC;
		ce : in  STD_LOGIC;
		rst : in  STD_LOGIC;
		q : out  STD_LOGIC_VECTOR (7 downto 0)
	);
end func1;

architecture Behavioral of func1 is

-- tmp signal is register to store calculated q value. Initial value is HEX "00"
signal tmp: unsigned(7 downto 0) := x"00";
-- pre_count is used to for generating the delay. Initial value is HEX "00...00" 
signal pre_count: unsigned(23 downto 0) := (others => '0'); 

begin

	process(clk, ce, rst)
	begin
	
		--TODO: This is where your counter goes.
		
	end process;

	-- Unsigned type is converted back to std_logic_vector
	q <= std_logic_vector(tmp(7 downto 0));
	
end Behavioral;
